package test;
import static org.junit.Assert.*;
import java.util.Arrays;
import java.util.function.DoubleConsumer;
import java.util.function.DoubleFunction;
import kadai.Money2;
import kadai.Yen2;
public class Ex2Test extends Ex1Test{
	public Ex2Test() {
		super();
	}
	protected <T extends Money2> void checkHashCode(DoubleFunction<T> constructor) {
		double[] sample = {1.0, 10.0, 1.0, 0.1, 2.0, 10.0, 500.0};
		Boolean[][] expect={
				{true, false, true, false, false, false, false},
				{false, true, false, false, false, true, false},
				{true, false, true, false, false, false, false},
				{false, false, false, true, false, false, false},
				{false, false, false, false, true, false, false},
				{false, true, false, false, false, true, false},
				{false, false, false, false, false, false, true}
		};
		int[] hashCodes = Arrays.stream(sample).mapToInt(x->constructor.apply(x).hashCode()).toArray();
		for(int i=0; i<hashCodes.length; i++){
			for(int j=0; i<hashCodes.length; i++){
				if(expect[i][j]){
					assertTrue(i+":"+j,hashCodes[i]==hashCodes[j]);
				}else{
					assertFalse(i+":"+j,hashCodes[i]==hashCodes[j]);
				}				
			}
		}
	}
	protected <T extends Money2> void checkCompareTo(DoubleFunction<T> constructor,
			DoubleConsumer setYenRate, double i){
		setYenRate.accept(80);
		Money2 m1 = constructor.apply(i);
		Money2 m2 = constructor.apply(i+10);
		Money2 m3 = constructor.apply(i);
		Money2 m4 = new Yen2(i);
		checkLarger(m1, m2, m3, m4);
		setYenRate.accept(1.0);
		checkSimilar(m1, m2, m3, m4);
	}
	protected void checkSimilar(Money2 m1, Money2 m2, Money2 m3, Money2 m4) {
		assertTrue(m1.compareTo(m1)==0);
		assertTrue(m1.compareTo (m2)<0);
		assertTrue(m1.compareTo (m3)==0);
		assertTrue(m1.compareTo (m4)==0);
		assertTrue(m2.compareTo(m1)>0);
		assertTrue(m2.compareTo (m2)==0);
		assertTrue(m2.compareTo (m3)>0);
		assertTrue(m2.compareTo (m4)>0);
		assertTrue(m3.compareTo(m1)==0);
		assertTrue(m3.compareTo (m2)<0);
		assertTrue(m3.compareTo (m3)==0);
		assertTrue(m3.compareTo (m4)==0);
		assertTrue(m4.compareTo(m1)==0);
		assertTrue(m4.compareTo (m2)<0);
		assertTrue(m4.compareTo (m3)==0);
		assertTrue(m4.compareTo (m4)==0);
	}
	protected void checkLarger(Money2 m1, Money2 m2, Money2 m3, Money2 m4) {
		assertTrue(m1.compareTo(m1)==0);
		assertTrue(m1.compareTo (m2)<0);
		assertTrue(m1.compareTo (m3)==0);
		assertTrue(m1.compareTo (m4)>0);
		assertTrue(m2.compareTo(m1)>0);
		assertTrue(m2.compareTo (m2)==0);
		assertTrue(m2.compareTo (m3)>0);
		assertTrue(m2.compareTo (m4)>0);
		assertTrue(m3.compareTo(m1)==0);
		assertTrue(m3.compareTo (m2)<0);
		assertTrue(m3.compareTo (m3)==0);
		assertTrue(m3.compareTo (m4)>0);
		assertTrue(m4.compareTo(m1)<0);
		assertTrue(m4.compareTo (m2)<0);
		assertTrue(m4.compareTo (m3)<0);
		assertTrue(m4.compareTo (m4)==0);
	}
	protected <T extends Money2> void checkEquals(DoubleFunction<T> constructor,
			DoubleConsumer setYenRate, double i) {
		setYenRate.accept(80);
		Money2 m1 = constructor.apply(i);
		Money2 m2 = constructor.apply(i+10);
		Money2 m3 = constructor.apply(i);
		Money2 m4 = new Yen2(i);
		String string = m1.toString();
		checkEqLarger(m1, m2, m3, m4, string);
		setYenRate.accept(1.0);
		checkEqSimilar(m1, m2, m3, m4, string);		
	}
	protected void checkEqSimilar(Money2 m1, Money2 m2, Money2 m3, Money2 m4,
			String string) {
		assertTrue(m1.equals(m1));
		assertFalse(m1.equals(null));
		assertFalse(m1.equals(string));
		assertFalse(m1.equals(m2));
		assertTrue(m1.equals(m3));
		assertTrue(m1.equals(m4));
	}
	protected void checkEqLarger(Money2 m1, Money2 m2, Money2 m3, Money2 m4,
			String string) {
		assertTrue(m1.equals(m1));
		assertFalse(m1.equals(null));
		assertFalse(m1.equals(string));
		assertFalse(m1.equals(m2));
		assertTrue(m1.equals(m3));
		assertFalse(m1.equals(m4));
	}
	protected <T extends Money2> void checkSetYenRate(DoubleFunction<T> constructor,
			DoubleConsumer setYenRate, double i, String string, double d, String string2,
			double e, String string3) throws ClassNotFoundException {
		Money2 m = constructor.apply(i);
		assertEquals(string, m.toString());
		setYenRate.accept(d);
		Money2 m2 = m.getYen();
		assertEquals(Class.forName("kadai.Yen2"),m2.getClass());
		assertEquals(string2,m2.toString());
		setYenRate.accept(e);
		Money2 m3 = m.getYen();
		assertEquals(string3,m3.toString());
	}
}