package test;

import static org.junit.Assert.*;
import kadai.Dollar2;
import kadai.Euro2;
import kadai.Money2;

public abstract class Ex2supplement {
	/**
	 * Yen2, Dollar2, Euro2 の順で、二つが等しくなるような組を
	 * 並べる。また、組同士はだんだん円換算の金額が大きくなるようにする。
	 */
	abstract protected  Money2[] getArray100140();
	private boolean[][] getDiagonal11(int n){
		boolean[][] e = new boolean[n][n];
		for(int i=0;i<n;i++){
			for(int j=0; j<n; j++){
				e[i][j]=(i==j);
			}
		}
		return e;
	}
	protected boolean[][] getDiagonal22(int n){
		boolean[][] e = new boolean[n][n];
		for(int i=0;i<n;i++){
			for(int j=0; j<n; j++){
				e[i][j]=((i/2)==(j/2));
			}
		}
		return e;
	}
	public void testEquals100140() {
		Money2[] a = getArray100140();
		boolean[][] expected=getDiagonal22(a.length);
		Dollar2.setYenRate(100);
		Euro2.setYenRate(140);
		for(int i=0; i<a.length; i++){
			for(int j=0; j<a.length; j++){
				String message=i+","+j;
				assertEquals(message,expected[i][j],a[i].equals(a[j]));
			}
		}
	}
	public void testEquals110160() {
		Money2[] a = getArray100140();
		boolean[][] expected=getDiagonal11(a.length);
		Dollar2.setYenRate(110);
		Euro2.setYenRate(160);
		for(int i=0; i<a.length; i++){
			for(int j=0; j<a.length; j++){
				String message=i+","+j;
				assertEquals(message,expected[i][j],a[i].equals(a[j]));
			}
		}
	}
	public void testHash100140() {
		Dollar2.setYenRate(100);
		Euro2.setYenRate(140);
		Money2[] a = getArray100140();
		for(int i=0; i<a.length; i++){
			for(int j=0; j<a.length; j++){
				String message=i+","+j;
				assertEquals(message,a[i].equals(a[j]),a[i].hashCode()==a[j].hashCode());
			}
		}
	}
	public void testHash110160() {
		Money2[] a = getArray100140();
		Dollar2.setYenRate(110);
		Euro2.setYenRate(160);
		for(int i=0; i<a.length; i++){
			for(int j=0; j<a.length; j++){
				String message=i+","+j;
				assertEquals(message,a[i].equals(a[j]),a[i].hashCode()==a[j].hashCode());
			}
		}
	}
	public void testCompareTo100140() {
		Money2[] a = getArray100140();
		Dollar2.setYenRate(100);
		Euro2.setYenRate(140);
		Eval[][] test = getDiagonal22Test(a.length);
		for(int i=0; i<a.length; i++){
			for(int j=0; j<a.length; j++){
				String message=i+","+j;
				test[i][j].assertion(message, a[i], a[j]);
			}
		}
	}
	public void testCompareTo110160() {
		Money2[] a = getArray100140();
		Dollar2.setYenRate(110);
		Euro2.setYenRate(160);
		Eval[][] test = getDiagonal11Test(a.length);
		for(int i=0; i<a.length; i++){
			for(int j=0; j<a.length; j++){
				String message=i+","+j;
				test[i][j].assertion(message, a[i], a[j]);
			}
		}
	}
	private Eval[][] getDiagonal11Test(int n){
		Eval[][] e = new Eval[n][n];
		for(int i=0;i<n;i++){
			for(int j=0; j<n; j++){
				e[i][j]=(i==j)? Eval.EVEN
						:(i<j)?Eval.LARGE
								: Eval.SMALL;
			}
		}
		return e;
	}
	private Eval[][] getDiagonal22Test(int n){
		Eval[][] e = new Eval[n][n];
		for(int i=0;i<n;i++){
			for(int j=0; j<n; j++){
				e[i][j]=((i/2)==(j/2))? Eval.EVEN
						:((i/2)<(j/2))?Eval.LARGE
								: Eval.SMALL;
			}
		}
		return e;
	}
	enum Eval {
		SMALL {
			@Override
			public void assertion(String message, Money2 a, Money2 b) {
				assertTrue(message,a.compareTo(b)>0);
			}
		},
		EVEN {
			@Override
			public void assertion(String message, Money2 a, Money2 b) {
				assertTrue(message,a.compareTo(b)==0);
			}
		},
		LARGE {
			@Override
			public void assertion(String message, Money2 a, Money2 b) {
				assertTrue(message,a.compareTo(b)<0);
			}
		};
		abstract public void assertion(String message,Money2 a, Money2 b);
	}
}
