package test;
import java.util.function.DoubleConsumer;
import java.util.function.DoubleFunction;
import kadai.Money2;
import kadai.Yen2;
import org.junit.Test;
public class Yen2Test  extends Ex2Test {
	@Test
	public void testCompareTo(){
		checkCompareTo(x->new Yen2(x),x->Yen2.setYenRate(x),110);
	}
	@Test
	public void testHashCode1(){
		Yen2.setYenRate(80);
		checkHashCode(x->new Yen2(x));
	}
	@Test
	public void testHashCode2(){
		Yen2.setYenRate(120);
		checkHashCode(x->new Yen2(x));
	}
	@Test 
	public void testEquals(){
		checkEquals(x->new Yen2(x),x->Yen2.setYenRate(x),110);
	}
	@Test
	public void testSetYenRate() throws ClassNotFoundException {
		checkSetYenRate(x->new Yen2(x),x->Yen2.setYenRate(x),
				3,"3.0円",80.0,"3.0円", 100.0, "3.0円");
	}
	@Test
	public void testToString() {
		checkToString(x->new Yen2(x),3.0, "3.0円");
	}
	@Override
	protected <T extends Money2> void checkCompareTo(DoubleFunction<T> constructor,
			DoubleConsumer setYenRate, double i){
		setYenRate.accept(80);
		Money2 m1 = constructor.apply(i);
		Money2 m2 = constructor.apply(i+10);
		Money2 m3 = constructor.apply(i);
		Money2 m4 = new Yen2(i);
		checkSimilar(m1, m2, m3, m4);
		setYenRate.accept(1.0);
		checkSimilar(m1, m2, m3, m4);
	}
	@Override
	protected <T extends Money2> void checkEquals(DoubleFunction<T> constructor,
			DoubleConsumer setYenRate, double i) {
		setYenRate.accept(80);
		Money2 m1 = constructor.apply(i);
		Money2 m2 = constructor.apply(i+10);
		Money2 m3 = constructor.apply(i);
		Money2 m4 = new Yen2(i);
		String string = m1.toString();
		checkEqSimilar(m1, m2, m3, m4, string);		
		setYenRate.accept(1.0);
		checkEqSimilar(m1, m2, m3, m4, string);		
	}
}


